import org.junit.Rule;
import org.junit.Test;

import java.lang.reflect.Array;
import java.lang.reflect.Method;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertThat;
import static org.hamcrest.CoreMatchers.is;

public class Aufgabe5Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testStaticAddFrac() throws Exception {
        int[] exp1 = new int[]{29, 40};
        int[] res1 = Aufgabe5.addFractions(3, 5, 1, 8);
        assertArrayEquals(exp1, res1);
        int[] exp2 = new int[]{0, 0};
        int[] res2 = Aufgabe5.addFractions(0, 0, 0, 0);
        assertArrayEquals(exp2, res2);
        int[] exp3 = new int[]{3960, 4840};
        int[] res3 = Aufgabe5.addFractions(12, 22, 60, 220);
        assertArrayEquals(exp3, res3);
    }

    @Test
    public void testObjectAddFrac() throws Exception {
        Fraction f1 = new Fraction(3, 5);
        Fraction f2 = new Fraction(1, 8);
        Fraction f3 = f1.addFrac(f2);
        assertThat("Add failed", f3.getNumerator(), is(29));
        assertThat("Add failed", f3.getDenominator(), is(40));
        Fraction f4 = new Fraction(0, 0);
        Fraction f5 = new Fraction(0, 0);
        Fraction f6 = f4.addFrac(f5);
        assertThat("Add failed", f6.getNumerator(), is(0));
        assertThat("Add failed", f6.getDenominator(), is(0));
        Fraction f7 = new Fraction(12, 22);
        Fraction f8 = new Fraction(60, 220);
        Fraction f9 = f7.addFrac(f8);
        assertThat("Add failed", f9.getNumerator(), is(9));
        assertThat("Add failed", f9.getDenominator(), is(11));
    }

    @Test
    public void testGCD() throws Exception {
        Method method = Fraction.class.getDeclaredMethod("gcd", int.class, int.class);
        method.setAccessible(true);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        Fraction myFrac1 = new Fraction(20,30);
        assertEquals(10, method.invoke(myFrac1, 20, 30));
        Fraction myFrac2 = new Fraction(1,1);
        assertEquals(1, method.invoke(myFrac2, 1, 1));
        Fraction myFrac3 = new Fraction(3,5);
        assertEquals(1, method.invoke(myFrac3, 3, 5));
    }

}